*.........................................................................................
*
*.........................................................................................

#include "L3wPars.ch"

FUNCTION main()

 SET( _SET_EPOCH, 2000 )
 SET CENTURY ON
 SET( _SET_DATEFORMAT, "dd-mm-yyyy" )
 SET( _SET_PATH, GetCurrentFolder() )
 SET( _SET_DEFAULT, GetCurrentFolder() )

 DefineForms()

 ACTIVATE WINDOW ALL

RETURN NIL

*.........................................................................................
* All forms defined here
*.........................................................................................
STATIC FUNCTION DefineForms()

 MainFrm_Define()

RETURN NIL

*.........................................................................................
* MainFrm definition
*.........................................................................................
STATIC FUNCTION MainFrm_Define()

 SET NAVIGATION EXTENDED

 DEFINE WINDOW MainFrm ;
  ROW 0 ;
  COL 0 ;
  WIDTH 860 ;
  HEIGHT 645 ;
  WINDOWTYPE MAIN ;
  TITLE "Parsing" ;
  ICON "pgmico" ;
  ON INIT MainFrm_OnInit() ;
  FONTNAME "Arial" FONTSIZE 10 ;
  NOTIFYICON "pgmico" ;
  NOTIFYTOOLTIP "L3W Parsing"

  DEFINE MAIN MENU
   DEFINE POPUP '&File'
    MENUITEM 'e&Xit' ACTION MainFrm_Exit()
   END POPUP
   DEFINE POPUP '&Test1'
    MENUITEM '&Fixed data'    ACTION FixedCnv()
    MENUITEM '&DataBase Data' ACTION WithDbCnv()
    MENUITEM '&Text 2 Array'  ACTION Txt2Arr()
   END POPUP
   DEFINE POPUP '&Test2'
    MENUITEM '&Load file'    ACTION LoadCnv()
   END POPUP
  END MENU

  DEFINE LABEL lb_input
   ROW 30
   COL 20
   VALUE "INPUT text"
   WIDTH 100
   HEIGHT 25
   ALIGNMENT Center
  END LABEL
  DEFINE EDITBOX InpText
   ROW 60
   COL 20
   WIDTH 600
   HEIGHT 200
   VALUE ""
   VSCROLLBAR .T.
   HSCROLLBAR .F.
  END EDITBOX

  DEFINE LABEL lb_output
   ROW 290
   COL 20
   VALUE "OUTPUT text"
   WIDTH 100
   HEIGHT 25
   ALIGNMENT Center
  END LABEL
  DEFINE EDITBOX OutText
   ROW 320
   COL 20
   WIDTH 600
   HEIGHT 200
   VALUE ""
   VSCROLLBAR .T.
   HSCROLLBAR .F.
  END EDITBOX

 END WINDOW

RETURN NIL

*.........................................................................................
* MainFrm OnInit event
*.........................................................................................
STATIC FUNCTION MainFrm_OnInit()

 LOCAL cText := ""
 
 MainFrm.Center

 cText += "This is a preload text to check functions" + HB_OSNEWLINE()
 cText += "Dear %TITLE% %LASTNAME% %FIRSTNAME%" + HB_OSNEWLINE()
 cText += "please check your data below:" + HB_OSNEWLINE()
 cText += "address %NUMBER% %STREET% " + HB_OSNEWLINE()
 cText += "%CITY%, %STATE% %ZIPCODE%" + HB_OSNEWLINE()
 cText += "country %COUNTRY%" + HB_OSNEWLINE()
 cText += "%ENDING% :: %ENDING% :: %ENDING%" + HB_OSNEWLINE()

 MainFrm.InpText.Value := cText

 CheckDb()

RETURN NIL

*.........................................................................................
* MainFrm menu exit event
*.........................................................................................
STATIC FUNCTION MainFrm_Exit()

 RELEASEALLWINDOWS()

RETURN NIL

*.........................................................................................
* fixed conversion
*.........................................................................................
STATIC FUNCTION FixedCnv()

 LOCAL oText

 oText := L3wText():New()
 oText:Text := MainFrm.InpText.Value

 oText:AddRule( "%TITLE%", "Mr." )
 oText:AddRule( "%LASTNAME%", "WILSON" )
 oText:AddRule( "%FIRSTNAME%", "BEN" )
 oText:AddRule( "%STREET%", "SOUTH STREET" )
 oText:AddRule( "%NUMBER%", "89" )
 oText:AddRule( "%CITY%", "NEW YORK" )
 oText:AddRule( "%STATE%", "NY" )
 oText:AddRule( "%ZIPCODE%", "10038-3520" )
 oText:AddRule( "%COUNTRY%", "UNITED STATES" )
 oText:AddRule( "%ENDING%", "_--_" )

 MainFrm.OutText.Value := oText:Parsing()

RETURN NIL

*.........................................................................................
* Data from DataBase
*.........................................................................................
STATIC FUNCTION WithDbCnv()

 LOCAL oText

 oText := L3wText():New()
 oText:Text := MainFrm.InpText.Value
 oText:Strip := .T.

 oText:AddRule( "%TITLE%", "title", "listdb" )
 oText:AddRule( "%LASTNAME%", "lastname", "listdb" )
 oText:AddRule( "%FIRSTNAME%", "firstname", "listdb" )
 oText:AddRule( "%STREET%", "street", "listdb" )
 oText:AddRule( "%NUMBER%", "number", "listdb" )
 oText:AddRule( "%CITY%", "city", "listdb" )
 oText:AddRule( "%STATE%", "state", "listdb" )
 oText:AddRule( "%ZIPCODE%", "zipcode", "listdb" )
 oText:AddRule( "%COUNTRY%", "country", "listdb" )
 oText:AddRule( "%ENDING%", "_--_" )

 listdb->(DBGOTOP())
 DO WHILE !listdb->(EOF())
  MainFrm.OutText.Value := oText:Parsing()
  MSGSTOP( "Record "+ LTRIM(STR(listdb->(RECNO()))) )
  listdb->(DBSKIP(+1))
 ENDDO

RETURN NIL

*.........................................................................................
* Text to Array
*.........................................................................................
STATIC FUNCTION Txt2Arr()

 LOCAL oText, nX

 oText := L3wText():New()
 oText:Text := MainFrm.InpText.Value
* aLines := oText:TxtToArr()
 oText:TxtToArr()
 FOR nX := 1 TO oText:Nline
  MSGSTOP( "Line " + LTRIM( STR( nX ) ) + HB_OSNEWLINE() + oText:Line(nX) )
 NEXT nX

RETURN NIL

*.........................................................................................
* Load a file
*.........................................................................................
STATIC FUNCTION LoadCnv()

 LOCAL oText

 oText := L3wText():New()
 oText:Fname := "loaded.txt"
 oText:Strip := .T.
 oText:AddRule( "%TITLE%", "Mr." )
 oText:AddRule( "%LASTNAME%", "WILSON" )
 oText:AddRule( "%FIRSTNAME%", "BEN" )
 oText:AddRule( "%STREET%", "SOUTH STREET" )
 oText:AddRule( "%NUMBER%", "89" )
 oText:AddRule( "%CITY%", "NEW YORK" )
 oText:AddRule( "%STATE%", "NY" )
 oText:AddRule( "%ZIPCODE%", "10038-3520" )
 oText:AddRule( "%COUNTRY%", "UNITED STATES" )
 oText:AddRule( "%ENDING%", "_--_" )

 MainFrm.OutText.Value := oText:Parsing()
 MainFrm.InpText.Value := oText:Text

RETURN NIL

*.........................................................................................
* check/create simple Db
*.........................................................................................
STATIC FUNCTION CheckDb()
 
 LOCAL aStru := {}, cText := ""

 IF FILE( "loaded.txt" ) == .F.
  cText += "This is a text from file to check functions" + HB_OSNEWLINE()
  cText += "Dear %TITLE% %LASTNAME% %FIRSTNAME%" + HB_OSNEWLINE()
  cText += "address %NUMBER% %STREET%" + HB_OSNEWLINE()
  cText += "%CITY%, %STATE% %ZIPCODE%" + HB_OSNEWLINE()
  cText += "country %COUNTRY%" + HB_OSNEWLINE()
  cText += "I'm very happy to meet you." + HB_OSNEWLINE()
  cText += "Bye" + HB_OSNEWLINE()
  MemoWrit ( "loaded.txt" , cText )
 ENDIF

 IF FILE( "listdb.dbf" ) == .F.
  AADD( aStru, { "TITLE",     "C",  4, 0 } )
  AADD( aStru, { "LASTNAME",  "C", 10, 0 } )
  AADD( aStru, { "FIRSTNAME", "C", 10, 0 } )
  AADD( aStru, { "NUMBER",    "C", 10, 0 } )
  AADD( aStru, { "STREET",    "C", 20, 0 } )
  AADD( aStru, { "CITY",      "C", 10, 0 } )
  AADD( aStru, { "STATE",     "C",  2, 0 } )
  AADD( aStru, { "ZIPCODE",   "C", 15, 0 } )
  AADD( aStru, { "COUNTRY",   "C", 15, 0 } )
  DBCREATE( "listdb.dbf", aStru )
  DBUSEAREA( .T., NIL, "listdb.dbf", "listdb", .T., .F. )
  DBSELECTAREA( "listdb" )
*
  listdb->( DBAPPEND() )
  listdb->title     := "MR"
  listdb->lastname  := "JOHNSON"
  listdb->firstname := "ANTHONY"
  listdb->number    := "130 EAST"
  listdb->street    := "7TH STREET"
  listdb->city      := "NEW YORK"
  listdb->state     := "NY"
  listdb->zipcode   := "10009-6164"
  listdb->country   := "UNITED STATES"
*
  listdb->( DBAPPEND() )
  listdb->title     := "MISS"
  listdb->lastname  := "BROWN"
  listdb->firstname := "ANNABEL"
  listdb->number    := "89"
  listdb->street    := "SOUTH STREET"
  listdb->city      := "NEW YORK"
  listdb->state     := "NY"
  listdb->zipcode   := "10038-3520"
  listdb->country   := "UNITED STATES"
*
  listdb->( DBAPPEND() )
  listdb->title     := "MR"
  listdb->lastname  := "SMITH"
  listdb->firstname := "BRAD"
  listdb->number    := "29 EAST"
  listdb->street    := "36TH STREET"
  listdb->city      := "NEW YORK"
  listdb->state     := "NY"
  listdb->zipcode   := "10016"
  listdb->country   := "UNITED STATES"
*
  listdb->( DBAPPEND() )
  listdb->title     := "MISS"
  listdb->lastname  := "MILLER"
  listdb->firstname := "BLANCHE"
  listdb->number    := "242"
  listdb->street    := "8TH AVENUE"
  listdb->city      := "NEW YORK"
  listdb->state     := "NY"
  listdb->zipcode   := "10011"
  listdb->country   := "UNITED STATES"
*
  listdb->( DBAPPEND() )
  listdb->title     := "MISS"
  listdb->lastname  := "TAYLOR"
  listdb->firstname := "BRITTANY"
  listdb->number    := "29"
  listdb->street    := "CORNELIA STREET"
  listdb->city      := "NEW YORK"
  listdb->state     := "NY"
  listdb->zipcode   := "10014"
  listdb->country   := "UNITED STATES"
*
  INDEX ON (listdb->lastname) TO ("listdb.ntx")
  DBCLOSEALL()
 ENDIF

 DBUSEAREA( .T., NIL, "listdb.dbf", "listdb", .T., .F. )
 listdb->( ORDLISTADD( "listdb.ntx" ) )

RETURN NIL
